;==============================================================================

print   proc
        mov ah, 9
        int 21h
        ret
print   endp

;==============================================================================

get     proc
        mov ah, 0ah
        int 21h
        ret
get     endp

;==============================================================================

cls     proc
        mov ax, 3
        int 10h
        ret
cls     endp

;==============================================================================

exit    proc
        mov ah, 4ch
        int 21h
        ret
exit    endp

;==============================================================================

lowcase0d  proc
        pushf
	pushad
	mov     edi,esi
	mov     al, 0dh
	xor     ecx,ecx
	dec     ecx
	cld
	repnz   scasb
	xor     edx,edx
	sub     edx,ecx
	dec     edx
	mov     ecx,edx
next_char:
        mov     al,[esi]
        cmp     al,41h
        jb      notupcase
        cmp     al,5ah
        ja      notupcase
        add     al,20h
        mov     [esi],al
notupcase:
        inc     esi
        dec     ecx
        test    ecx,ecx
        jnz     next_char
	popad
	popf
        ret
lowcase0d  endp

; ============================================================================

num2str proc
        std
        mov     ebx, 16
@loop:  or      eax, eax
        jz      @done
        xor     edx, edx
        div     ebx
        xchg    eax, edx
        add     al, '0'
        cmp     al, '9'
        jle     @here
        add     al, 07h
@here:  stosb
        xchg    eax, edx
        jmp     @loop
@done:  inc     di
        cld
        retn
num2str endp

; ============================================================================

str2hnum        proc
	pushf
	push    ebx ecx edi esi ebp
        mov     ebp, 10h
        xor     eax, eax
        xor     ebx, ebx
nextchar:
        xor     edx, edx
        imul    ebx, ebx, 10h
        mul     ebp
        add     ebx, edx
        movzx   edi, byte ptr [esi]
	cmp     edi, 40h
	jl      number
	sub     edi,7
number:
        add     eax, edi
        adc     ebx, 0
        sub     eax, 30h
        inc     esi
        dec     ecx
        jnz     nextchar
        xchg    edx, ebx
	pop     ebp esi edi ecx ebx
	popf
        ret
str2hnum        endp

; ============================================================================

upcase          proc
        pushf
        pushad
        mov     edi,esi
        mov     al,0h
        xor     ecx,ecx
        dec     ecx
        cld
        repnz   scasb
        xor     edx,edx
        sub     edx,ecx
        dec     edx
        mov     ecx,edx
nextletter:
        mov     al,[esi]
        cmp     al, 61h
        jb      notlowcase
        cmp     al,7ah
        ja      notlowcase
        sub     al,20h
        mov     [esi],al
notlowcase:
        inc     esi
        dec     ecx
        test    ecx,ecx
        jnz     nextletter
        popad
        popf
        ret
upcase          endp

;=============================================================================

upcase0d        proc
	pushf
	pushad
	mov     edi,esi
	mov     al, 0dh
	xor     ecx,ecx
	dec     ecx
	cld
	repnz   scasb
	xor     edx,edx
	sub     edx,ecx
	dec     edx
	mov     ecx,edx
next_letter:
        mov     al,[esi]
        cmp     al, 61h
        jb      not_lowcase
        cmp     al,7ah
        ja      not_lowcase
        sub     al,20h
        mov     [esi],al
not_lowcase:
        inc     esi
        dec     ecx
        test    ecx,ecx
        jnz     next_letter
	popad
	popf
        ret
upcase0d        endp

;==============================================================================

write_decimal_number    proc
        push    edx
        push    ecx
        push    esi
        mov     esi,10
        xor     ecx,ecx
not_zero:
        xor     edx,edx
        div     esi
        push    edx
        inc     ecx
        or      eax,eax
        jne     not_zero
write_digit_loop:
        pop     edx
        call    write_ascii_number
        loop    write_digit_loop
        pop     esi
        pop     ecx
        pop     edx
        ret
write_decimal_number    endp

write_ascii_number      proc
        cmp     dl,10
        jae     hex_number
        add     dl,30h
        jmp     short write_number
hex_number:
        add     dl,41h -10
write_number:
        call    write_char
        ret
write_ascii_number      endp

write_char              proc
        push    ax
        mov     ah,2
        int     21h
        pop     ax
        ret
write_char              endp
