;-[PROC]-------------------------------------------------------
        WRITE_DECIMAL_NUMBER PROC
        PUSH EDX
        PUSH ECX
        PUSH ESI

        MOV  ESI,10          ;moves the value 10 to register SI

        XOR  ECX,ECX         ;clears the register  CX
NOT_ZERO:
        XOR  EDX,EDX         ;clears the register DX
        DIV  ESI              ;divides operation between SI
        PUSH EDX             ;Pushes one digit number in the stack memory
        INC  ECX
	 OR   EAX,EAX
        JNE  NOT_ZERO

WRITE_DIGIT_LOOP:

        POP  EDX             ;get numbers in reverse order.

        CALL WRITE_ASCII_NUMBER

        LOOP WRITE_DIGIT_LOOP

        POP ESI
        POP ECX
        POP EDX
        RET
WRITE_DECIMAL_NUMBER ENDP
;--------------------------------------------------------------
WRITE_ASCII_NUMBER PROC
        CMP  DL,10              ;Compares the value 10 with the value of the register DL
        JAE  HEX_NUMBER
        ADD  DL,30H             ;yes, converts into ascii (1-9)
        JMP  Short WRITE_NUMBER ;writes the character
HEX_NUMBER:
        ADD  DL,41H -10         ;converts into ascii (A-F)

WRITE_NUMBER:                   ; Write number...
        CALL WRITE_CHAR
        RET
WRITE_ASCII_NUMBER ENDP
;--------------------------------------------------------------
WRITE_CHAR PROC
        PUSH AX
        MOV  AH,2
        INT  21h
        POP  AX
        RET
WRITE_CHAR ENDP
;--------------------------------------------------------------
