.386
.MODEL FLAT,STDCALL
locals
jumps

UNICODE=0			;Not Unicode
;
;This is an example of how to create a VERY simple dialog based application
;using win32 asm.
;If you have any questions come to #win32asm on EFnet.
;

include res.inc			;Resource Includes (from resource.h if you use VC++ Resource Editor)
include \tasm\include\w32.inc	;Win 32 Definitions


ICON_SMALL	equ 0

extrn DrawIcon:proc
extrn _wsprintfA:proc		;This isn't in w32.inc

.DATA


szName		 db 31 dup(?)	;The user's name
szSerial	 db 35 dup(?)	;The 'Serial' #

blank           db 35 dup(0)
alphabet        db 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz. ',00
encrypted       db 'XcgjH3uKTawSL6CrGRUJvFyAfkNBQsMEzPoDxtqZ78einYpWdhmVb4',00
temp_4          db 5 dup(0)

_hInst          dd ?		;the hInst
_hWnd	        dd ?		;Window Handle
_hIcon		dd ?

done		dd 0		        ;To tell it to exit the app
; fmat		db "%-010.10li",0	;The format string for wsprintf

_msg             MSG         <?> ;The message Structure
_pnt		 PAINTSTRUCT <?>
DlgRect 	 RECT <>			
DlgWidth 	 dd ?
DlgHeight 	 dd ?
DesktopRect 	 RECT <>

.CODE

;-------

main:
        call GetModuleHandle, NULL	;Get the handle to our app
        mov     _hinst, eax		;Store it
	xor	eax, eax		;clear eax
	mov	ax, IDD_DIALOG1		;load the handle of the dialog into eax
	push	0			;Initialization Value...we don't need it, make it 0
	push	offset DlgProc		;Pointer to the Procedure which handles messages for the dialog
	push	0			;We have no owner window, so this can be null
	push	eax			;The dialog that we want to load
	push	_hinst			;The hInst
	call	DialogBoxParamA		;Create the Dialog

@looperz:	
	call	GetMessage, offset _msg,0,0,0	;The message loop, first get the message
	cmp	ax, 0				;If WM_QUIT message was received
	je	die				;Exit the loop (and the prog)
	call	TranslateMessage, offset _msg	;Translate the Message
	call	DispatchMessage, offset _msg	;Dispatch the Message
	cmp	done, 1				;See if we're done
	jne	@looperz			;Loop
	
die:
	call	ExitProcess			;Exit the Program
	

;
;The DlgProc, handles messages for the Dialog Box
;See API Ref for info on the variables passed to it
;

PUBLIC DlgProc
DlgProc proc STDCALL, __hwnd:DWORD, wmsg:DWORD, _wparam:DWORD, _lparam:DWORD
    USES  ebx, edi, esi


xor	eax,eax				;Clear eax
mov 	ax, word ptr [wmsg]		;Put the message into eax

.IF ax==WM_DESTROY			;Was the msg WM_DESTROY
 jmp  _wmdestroy			;If so, destroy the window
.ELSEIF ax==WM_CLOSE			;Same thing if it's WM_CLOSE
 jmp  _wmdestroy
.ELSEIF ax==WM_COMMAND			;WM_COMMAND means something interesting happened
 jmp	_wmcommand			;So process it
.ELSEIF ax==WM_INITDIALOG		;Code runs when the dialog is first initialized
 jmp	_initdlg
.ELSEIF ax==WM_PAINT			;Code runs on WM_PAINT
 jmp	_paint
;.ELSE
; call 	DefWindowProcA, __hwnd, wmsg,_wparam,_lparam
.ENDIF					
xor eax,eax
ret					;Exit the message loop, return 0

_wmdestroy:
push	0				;Return 0
push	__hWnd				;The handle of the Dialog
call	EndDialog			;End the Dialog
call	ExitProcess			;Exit Process
mov	done, 1				;This wasn't working even before i added the ExitProcess call ;)
ret

_wmcommand:
cmp	word ptr [_wparam], IDC_EDIT1	;See if the user entered some text into the edit box
jne	@Next				;If not go to the next compare
call	GenKey, __hWnd			;If they did, generate their key
@Next:
cmp	_wparam, IDOK			;Did they press the OK button?
je	_wmdestroy			;If yes, destroy the dialog
@teo:
ret

_initdlg:
;
;Here we will put the icon on the dialog and center the dialog
;
push	IDI_ICON			;The Icon Identifier, from the resource file (included in res.inc)
push	_hinst				;The hInstance
call	LoadIcon			;Load the Icon

mov	_hIcon, eax			;Store the Icon handle
push	eax				;Push it for the call to load the icon into the titlebar
push	ICON_SMALL			;The icon to be used in the title bar is the small icon
push	WM_SETICON			;The message to send
push	__hwnd				;The window handle
call	SendMessage			;Send the Message

;
;Code to center the dialog
;Code donated by Iczelion (commented by rudeboy)
;Thanks Iczelion!!
;
   push OFFSET DlgRect			;Ptr to the Rect struct that will store the coordinates
   push __hwnd				;The window handle
   call GetWindowRect			;
   call GetDesktopWindow		;get the handle to the Desktop window
   push OFFSET DesktopRect		;offset to the Rect struct that holds the size ofthe desktop
   push eax                       	;The hWnd ofthe desktop
   call GetWindowRect			;Get the info
   push  0				;Part of the later call to MoveWindow (no repaint)
   mov  eax,DlgRect.rc_bottom		;Get the bottom of our dialogs window
   sub  eax,DlgRect.rc_top		;subtract the y value at the top of our window
   mov  DlgHeight,eax			;And store it as the dialog's height
   push eax				;Push it for the call to MoveWindow
   mov  eax,DlgRect.rc_right		;The X coordinate of the right side of our dialog
   sub  eax,DlgRect.rc_left		;minus that of the left side
   mov  DlgWidth,eax			;gives us the width
   push eax				;Push it for the call to MoveWindow
   mov  eax,DesktopRect.rc_bottom	;Get the bottom of the desktop window
   sub  eax,DlgHeight			;Subtract the height of our dialog
   shr  eax,1				;and divide by 2...this gives the middle of the screen
   push eax				;Push for the movewindow call
   mov  eax,DesktopRect.rc_right	;Get the right side of the desktop
   sub  eax,DlgWidth			;Minus the width of our dialog
   shr  eax,1				;Divide by 2
   push eax				;Push it
   push  __hwnd				;Push the window handle
   call MoveWindow			;Move the window
ret

_paint:
push	offset _pnt			;Push the paint structure
push	__hwnd				;The window handle
call	BeginPaint			;BeginPainting

;This is where we display the icon below the 'OK' button
push	_hIcon				;Icon Handle
push	35				;the location to draw at
push	277
push	eax				;The hDc (returned by BeginPaint)
call	DrawIcon			;Draw it
	
push	offset _pnt			;End our painting session
push	__hwnd
call	EndPaint
ret

DlgProc ENDP



GenKey proc _hDlg:dword
uses ebx, edx

        mov     esi, offset blank
        mov     edi, offset szSerial
        mov     ecx, 45
        rep     movsb
	push	offset szSerial		;Pointer to the 'serial'
	push	IDC_EDIT2		;The edit box to put the info into
	push	_hDlg			;The dialog handle
	call	SetDlgItemTextA		;Set the text
	mov	eax, 1			;set the return value

	push	40			;The max length of the string to get
	push	offset szName		;Pointer to the Name string
	push	IDC_EDIT1		;The text box to get the string from
	push	_hDlg			;The handle of the dialog
	call	GetDlgItemTextA		;Get the Name


	lea	eax, szName		
	cmp 	byte ptr [eax], 0	;See if there is anything in the name
	je	ExitProc0		;If not, exit the proc
        cmp     byte ptr [eax+2], 0
        je      ExitProc0


	xor 	ebx, ebx		;Clear ebx
        xor     edx, edx
        xor     edi, edi
	lea	eax, szName

@loop_outer:


        mov     esi, offset [encrypted]
        mov     edx, offset [alphabet]
@loop:

        mov     bl, byte ptr [eax]
        cmp     byte ptr [edx], bl
        jz      @part_completed
        inc     edx
        cmp     byte ptr [edx], 00
        jnz     not_at_end
        mov     byte ptr [szSerial+4+edi], bl
        inc     eax
        inc     edi
        cmp     byte ptr [eax], 0
	jnz     @loop_outer
        jmp     forward
not_at_end:
	jmp	@loop
@part_completed:
        sub     edx, offset [alphabet]
        add     esi, edx
        mov     dl, byte ptr [esi]
        mov     byte ptr [szSerial+4+edi], dl
	inc     eax
        inc     edi
        cmp     byte ptr [eax], 0
	jnz     @loop_outer
forward:
        mov     esi, offset [szSerial+4]
        mov     eax, 213h
        xor     ecx, ecx
@not_all_added:
        cmp     byte ptr [esi+ecx], 0
        jz      @forward
        mov     bl, byte ptr [esi+ecx]
        add     eax, ebx
        inc     ecx
        jmp     @not_all_added
@forward:
        jmp     @over_the_sub
@back_to_the_sub:
        sub     eax, 141h
@over_the_sub:
        cmp     eax, 279Fh
        jg      @back_to_the_sub
        jmp     @over_the_add
@back_to_the_add:
        add     eax, 1984h
@over_the_add:
        cmp     eax, 3e8h
        jl      @back_to_the_add

        mov     ecx, 0Ah
        xor     esi, esi
@not_finished_first_4:
        xor     edx, edx
        idiv    ecx
        add     dl, 30h
        mov     byte ptr [temp_4 + esi], dl
        inc     esi
        cmp     esi, 4
        jl      @not_finished_first_4

        mov     esi, offset [temp_4]
        mov     al, byte ptr [esi]
        mov     dl, byte ptr [esi+3]
        mov     byte ptr [esi+3], al
        mov     byte ptr [esi], dl
        mov     al, byte ptr [esi+1]
        mov     dl, byte ptr [esi+2]
        mov     byte ptr [esi+1], dl
        mov     byte ptr [esi+2], al

        xor     edi, edi
@final_part_not_done:
        mov     edx, offset [encrypted]
        mov     al, byte ptr [esi]
        sub     al, 24h
        add     edx, eax
        mov     cl, byte ptr [edx]
        mov     byte ptr [szSerial+edi], cl
        inc     edi
        inc     esi
        cmp     edi, 4
        jl      @final_part_not_done



	
;	push	edx			;The 'Serial'
;	push	offset fmat		;The format string
;	push	offset szSerial		;Pointer to the serial #
;	call	_wsprintfA		;call wsprintf
	
	push	offset szSerial		;Pointer to the 'serial'
	push	IDC_EDIT2		;The edit box to put the info into
	push	_hDlg			;The dialog handle
	call	SetDlgItemTextA		;Set the text
	mov	eax, 1			;set the return value
	ret				;return
ExitProc0:
	xor 	eax, eax		;set return value
	ret				;return
GenKey endp

ends
end main				;That's all folks!
