; Memory patch for NeoTrace v1.22
; (eliminates the nag when closing)

.386p
jumps
locals
.model flat,stdcall

UNICODE=0

include w32.inc

extrn   WaitForInputIdle        :proc
extrn   ReadProcessMemory       :proc
extrn   WriteProcessMemory      :proc

.DATA

Address         dd      40A61Bh
Old_Bytes       db      6Ah,00,68h,0E0h,8Ch,40h
Old_Num         dd      6
New_Bytes       db      0EBh, 62h
New_Num         dd      2
FileName        db      'NEOTRACE.EXE', 0

Buffer          db      10h dup (0)
Error           db      'Error', 0
Create_Error    db      'CreateProcess failed!', 0
Read_Error      db      'ReadProcessMemory failed!', 0
Write_Error     db      'WriteProcessMemory failed!', 0
Wrong_Bytes     db      'Patch failed!', 0
About           db      'About',0
Message         db      'NeoTrace v1.22',0

sinfo           STARTUPINFO             <0>
pinfo           PROCESS_INFORMATION     <0>

.CODE
Start:
        call    GetCommandLineA
        mov     edi, eax
        mov     esi, edi
        xor     ecx, ecx
        dec     ecx
        xor     eax, eax
        repne   scasb
        dec     edi
        sub     edi, esi
        mov     ecx, edi
        mov     edi, esi
        mov     al, 20h
        repne   scasb
        rep     scasb
        or      ecx, ecx
        jne     go
        dec     edi
        cmp     byte ptr [edi], 'v'
        jne     go
about:
        push MB_OK
        push offset About
        push offset Message
        push NULL
        call MessageBoxA
        jmp quit
go:
        mov [sinfo.si_cb], STARTUPINFO_
        push offset pinfo
        push offset sinfo
        push NULL
        push NULL
        push NORMAL_PRIORITY_CLASS
        push FALSE
        push NULL
        push NULL
        push NULL
        push offset FileName
        call CreateProcessA
        cmp eax, 0
        jnz init

        push MB_OK
        push offset Error
        push offset Create_Error
        push NULL
        call MessageBoxA
        jmp quit
init:
        push INFINITE
        push pinfo.pi_hProcess
        call WaitForInputIdle

        push NULL
        push Old_Num
        push offset Buffer
        push Address
        push pinfo.pi_hProcess
        call ReadProcessMemory
        cmp eax, 0
        jnz check

        push MB_OK
        push offset Error
        push offset Read_Error
        push NULL
        call MessageBoxA
        jmp done
check:
        xor edi, edi
        xor edx, edx
        lea esi, Old_Num
        sub byte ptr [esi], 1
        jmp dummy
loop:
        inc edi
dummy:  mov dl, byte ptr [edi+Buffer]
        cmp dl, byte ptr [edi+Old_Bytes]
        jne end
        cmp edi, [esi]
        jne loop
end:    cmp edi, [esi]
        je ok

        push MB_OK
        push offset Error
        push offset Wrong_Bytes
        push NULL
        call MessageBoxA
        jmp done
ok:
        push NULL
        push New_Num
        push offset New_Bytes
        push Address
        push pinfo.pi_hProcess
        call WriteProcessMemory
        cmp eax, 0
        jnz done

        push MB_OK
        push offset Error
        push offset Write_Error
        call MessageBoxA
done:
        push pinfo.pi_hProcess
        call CloseHandle
        push pinfo.pi_hThread
        call CloseHandle
quit:
        call ExitProcess, 0

END     Start
